<template>
  <div
    data-component-group="user-form"
    data-component="invite"
  >
    <form @:submit.prevent="onSubmit">
      <v-flex xs12>
        <v-layout>
          <v-flex xs6>
            <v-text-field
              v-model="firstName"
              prepend-inner-icon="account_box"
              :label="$t('components.forms.user_profile.first_name_placeholder')"
              type="text"
              :autofocus="true"
              :error-messages="firstNameErrors"
              @blur="$v.firstName.$touch()"
            />
          </v-flex>
          <v-flex xs6>
            <v-text-field
              v-model="lastName"
              prepend-inner-icon="contacts"
              :label="$t('components.forms.user_profile.last_name_placeholder')"
              type="text"
              :error-messages="lastNameErrors"
              @blur="$v.lastName.$touch()"
            />
          </v-flex>
        </v-layout>
      </v-flex>

      <v-text-field
        v-model="email"
        :label="$t('components.forms.user_profile.email_placeholder')"
        prepend-inner-icon="email"
        type="text"
        :error-messages="emailErrors"
        @blur="$v.email.$touch()"
      />

      <layout-section-header
        title="Settings"
        :has-trigger="false"
      />

      <v-autocomplete
        v-model="role"
        :items="roles"
        :filter="customFilter"
        label="Role"
        item-text="name"
        item-value="code"
        :return-object="true"
        :readonly="isSuperAdmin || isDisabled"
        :error-messages="roleErrors"
        prepend-inner-icon="contacts"
        :menu-props="{nudgeBottom:'10'}"
        @blur="$v.role.$touch()"
      />

      <template v-if="hasRole && !isBusinessAdminRole">
        <v-autocomplete
          v-model="restrictedCountries"
          :items="countries"
          :filter="customFilter"
          :multiple="true"
          prepend-inner-icon="public"
          label="Restrict access to countries"
          item-text="name"
          item-value="code"
          :return-object="true"
          :menu-props="{nudgeBottom:'10'}"
        />

        <layout-section-header
          title="Deal submission limits"
          :has-trigger="false"
        />

        <ThreadSubmissionLimits
          trigger-label="Add"
          trigger-icon="add"
          :limits="submissionLimits"
          :on-submit="onAddSubmissionLimit"
          :on-remove="onRemoveSubmissionLimit"
        />

        <layout-section-header
          title="Category limits"
          :has-trigger="false"
        />

        <CategoryLimits
          :limits="categoryLimits"
          :on-submit="onAddCategoryLimit"
          :on-remove="onRemoveCategoryLimit"
        />

        <layout-section-header
          title="Campaign limits"
          :has-trigger="false"
        />

        <v-autocomplete
          v-model="campaignCountries"
          :items="countries"
          :filter="customFilter"
          :multiple="true"
          prepend-inner-icon="public"
          label="Country"
          item-text="name"
          item-value="code"
          :return-object="true"
          :menu-props="{nudgeBottom:'10'}"
        />
      </template>

      <div class="form-actions">
        <v-btn
          v-if="onCancel"
          color="secondary"
          depressed
          @click="cancel"
        >
          {{ cancelTriggerLabel }}
        </v-btn>
        <v-btn
          v-if="onSubmit && !isDisabled"
          color="primary"
          class="trigger"
          depressed
          :loading="isLoading"
          @click="submit"
        >
          <v-icon>
            {{ submitTriggerIcon }}
          </v-icon>
          {{ confirmTriggerLabel }}
        </v-btn>
      </div>
    </form>
  </div>
</template>

<script>
  import { validationMixin } from 'vuelidate';
  import { required, email } from 'vuelidate/lib/validators';
  import colors from 'vuetify/es5/util/colors';
  import ThreadSubmissionLimits from '../businesses/ThreadSubmissionLimits';
  import CategoryLimits from './CategoryLimits';
  import router from '../../../router';
  import { isNum, isObj } from '../../../utils';

  // TODO: Translate component

  export default {
    components: {
      ThreadSubmissionLimits,
      CategoryLimits
    },
    mixins: [validationMixin],
    validations() {
      return {
        firstName: {
          required
        },
        lastName: {
          required
        },
        email: {
          required,
          email
        },
        role: {
          required
        }
      };
    },
    props: {
      user: {
        type: Object,
        default: undefined
      },
      cancelTriggerLabel: {
        type: String,
        default: 'Cancel'
      },
      confirmTriggerLabel: {
        type: String,
        default: 'Invite user'
      },
      submitTriggerIcon: {
        type: String,
        default: 'person_add'
      },
      isLoading: {
        type: Boolean,
        default: false
      },
      isDisabled: {
        type: Boolean,
        default: false
      },
      onCancel: {
        type: Function,
        default: undefined
      },
      onSubmit: {
        type: Function,
        default: undefined
      },
    },
    data: () => ({
      firstName: '',
      lastName: '',
      email: '',
      role: {},
      restrictedCountries: [],
      submissionLimits: [],
      campaignCountries: [],
      categoryLimits: [],
      isSubmitted: false,
      colors
    }),
    computed: {
      roles() {
        return this.$store.getters['users/subRoles'];
      },
      hasRole() {
        return isObj(this.role) && isNum(this.role.code);
      },
      isBusinessAdminRole() {
        return this.role.code === 1;
      },
      country() {
        return this.$store.getters['config/country'];
      },
      countries() {
        return this.$store.getters['users/countries'];
      },
      languages() {
        return this.$store.getters['config/languages'];
      },
      timezones() {
        return this.$store.getters['config/timezones'];
      },
      hasCountry() {
        const { code = '' } = this.role;
        return code && code !== 'business_contact';
      },
      hasUser() {
        return isObj(this.user);
      },
      isBusinessContact() {
        const { code = '' } = this.role;
        return code === 'business_contact';
      },
      isSuperAdmin() {
        const { code = '' } = this.role;
        return code === 'super_admin';
      },
      firstNameErrors() {
        const errors = [];
        if (!this.$v.firstName.$dirty) {
          return errors;
        }
        if (!this.$v.firstName.required) {
          errors.push(router.app.$t('components.forms.user_profile.errors.first_name_required'));
        }
        return errors;
      },
      lastNameErrors() {
        const errors = [];
        if (!this.$v.lastName.$dirty) {
          return errors;
        }
        if (!this.$v.lastName.required) {
          errors.push(router.app.$t('components.forms.user_profile.errors.last_name_required'));
        }
        return errors;
      },
      emailErrors() {
        const errors = [];
        if (!this.$v.email.$dirty) {
          return errors;
        }
        if (!this.$v.email.required) {
          errors.push(router.app.$t('components.forms.confirm_business.errors.email_required'));
        }
        if (!this.$v.email.email) {
          errors.push(router.app.$t('components.forms.confirm_business.errors.email_valid'));
        }
        return errors;
      },
      roleErrors() {
        const errors = [];
        if (!this.$v.role.$dirty) {
          return errors;
        }
        if (!this.$v.role.required) {
          errors.push('Role is required');
        }
        return errors;
      }
    },
    watch: {
      user(nextUser) {
        this.clear();

        if (isObj(nextUser)) {
          this.extractUserData(nextUser);
        }
      }
    },
    created() {
      this.getSubroles();
    },
    methods: {
      getSubroles() {
        return this.$store.dispatch('users/getSubRoles');
      },
      cancel() {
        this.clear();
        this.onCancel();
      },
      submit() {
        this.$v.$touch();

        if (!this.canSubmitRequest() || this.$v.$error || this.$v.pending) {
          return false;
        }

        this.addUser();
      },
      clear() {
        this.$v.$reset();
        this.firstName = '';
        this.lastName = '';
        this.email = '';
        this.role = {};
        this.restrictedCountries = [];
        this.submissionLimits = [];
        this.campaignCountries = [];
        this.categoryLimits = [];
        this.isSubmitted = false;
      },
      addUser() {
        const { firstName, lastName, email, restrictedCountries, submissionLimits, campaignCountries, categoryLimits, isBusinessAdminRole } = this;

        const user = {
          firstname: firstName,
          lastname: lastName,
          email,
          is_business_admin: isBusinessAdminRole ? 1 : 0
        };

        if (restrictedCountries.length > 0) {
          user.restricted_countries = restrictedCountries.map(({ code }) => code);
        }

        if (campaignCountries.length > 0) {
          user.restricted_campaign_countries = campaignCountries.map(({ code }) => code);
        }

        if (submissionLimits.length > 0) {
          user.submission_limits = submissionLimits.map(({ max_deals_per_week, max_deals_per_day, country_limits }) => ({
            max_deals_per_week,
            max_deals_per_day,
            country_limits: country_limits.code
          }));
        }

        if (categoryLimits.length > 0) {
          user.category_limits = categoryLimits.map(({ categories, country }) => ({
            categories: categories.map(({ code }) => code).join(', '),
            category_limits_country: country.code
          }));
        }

        return this.onSubmit(user)
          .then(() => {
            const hasErrors = this.$store.getters['alerts/error'].length > 0;
            if (hasErrors) {
              return false;
            }

            return this.clear();
          });
      },
      canSubmitRequest() {
        const { firstName, lastName, email, hasRole, isSubmitted } = this;

        return firstName !== ''
          && lastName !== ''
          && email !== ''
          && hasRole
          && !isSubmitted;
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      },
      extractUserData(user) {
        const role = this.roles.find(role => role.code === user.role.slug);

        this.firstName = user.firstname;
        this.lastName = user.lastname;
        this.email = user.email;
        this.role = role;
        this.restrictedCountries = user.countries;
      },
      onAddSubmissionLimit({ weekly, daily, country }) {
        const { submissionLimits } = this;
        const nextSubmissionLimit = {
          max_deals_per_week: weekly,
          max_deals_per_day: daily,
          country_limits: country
        };

        const uniqueSubmissionLimits = submissionLimits
          .filter(({ country_limits }) => country_limits.code !== country.code);
        this.submissionLimits = [...uniqueSubmissionLimits, nextSubmissionLimit];
      },
      onRemoveSubmissionLimit(item) {
        this.submissionLimits = this.submissionLimits
          .filter(({ country_limits }) => country_limits.code !== item.country_limits.code);
      },
      onAddCategoryLimit({ categories, country }) {
        const { categoryLimits } = this;
        const nextCategoryLimits = {
          categories,
          country
        };

        const uniqueCategoryLimits = categoryLimits
          .filter((item) => item.country.code !== country.code);
        this.categoryLimits = [...uniqueCategoryLimits, nextCategoryLimits];
      },
      onRemoveCategoryLimit(item) {
        this.categoryLimits = this.categoryLimits
          .filter(({ country }) => country.code !== item.country.code);
      }
    }
  };
</script>

<style lang="stylus" scoped>
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="user-form"] {
    &[data-component="invite"] {
      .form-actions {
        display: flex;
        justify-content: flex-end;
        align-items: center;

        .v-btn {
          border-radius: 4px;

          &.trigger {
            .v-icon {
              margin: 0 6px 0 0;
            }
          }

          &:last-child {
            margin-right: 0;
          }
        }
      }
    }
  }
</style>
